''Prop-Bot v1.0
''Steering Test

VAR

long Counter
long Distance
long Steer_Ang
long speed1
long stack[20]

Con

_clkmode = xtal1 + pll16x               'Clock Mode
_xinfreq = 5_000_000                    'Crystel Speed

Right_Max = 1830                        'Right Max For Steering
Center    = 1700                        'Center Steering
Left_Max  = 1500                        'Left Max for Steering
High = 1
Low  = 0

Steer_Pin = 0
Ping_Turn = 1
Ping_Pin  = 2

Forward    = %01
Backward   = %10
Stop       = %00

OBJ

Ping   : "Ping"
PWM[2] : "MotorPWM"
Pub Main  | Open_Angle
  Dira[14..15] := %11                                    'Motor Drives Pins --> Output
  Outa[14..15] := Stop                                   'Motor Off
  Flash_LED(16)
  Drive_Servo(Steer_Pin, Center)
  Drive_Servo(Ping_Turn, 1475)
  Flash_LED(16)
  PWM[0].Start(14, 17, 256)
  PWM[0].update(0)

  PWM[1].Start(15, 17, 256)
  PWM[1].update(0)

  if Ping.Inches(Ping_Pin) > 36
    cognew(Throttle_up, @stack)

  repeat
    Distance := Ping.Inches(Ping_Pin)
    if Distance < 30
      All_Stop
      Open_Angle := Ping_Scan(Ping_Pin, Ping_Turn)
      Compare_Angle(Open_Angle)
      cognew(Throttle_up, @stack)
    else
      waitcnt(10_000_000 + cnt)

PUB Throttle_up
  repeat speed1 from 25 to 50
    PWM[0].update(speed1)
    waitcnt(1_000_000 + cnt)    
PUB Compare_Angle(angle)
  if angle == 1
    Turn_Left
  elseif angle == -1
    Turn_Right
      
PUB All_Stop
  PWM[0].update(0)
  PWM[1].update(0)

  repeat speed1 from 15 to 25
    PWM[1].update(speed1)
    waitcnt(5_000_000 + cnt)

  PWM[1].update(0)  
  
PUB Turn_Left
  PWM[0].update(0)
  PWM[1].update(40)

  repeat 45
    Pulsout(Steer_Pin, Right_Max, High)
    waitcnt(1_600_000 + cnt)
    
  PWM[1].update(0)
  
  waitcnt(80_000_000 + cnt)
  
  PWM[0].update(40)
  repeat 45
    Pulsout(Steer_Pin, Left_Max, High)
    waitcnt(1_600_000 + cnt)

  PWM[0].update(0)  
  Drive_Servo(Steer_Pin, center)

PUB Turn_Right
  PWM[0].update(0)
  PWM[1].update(40)
  
  repeat 45
    Pulsout(Steer_Pin, Left_Max, High)
    waitcnt(1_600_000 + cnt)

 
  PWM[1].update(0)
  waitcnt(80_000_000 + cnt)
  PWM[0].update(40)
  repeat 45 
    Pulsout(Steer_Pin, Right_Max, High)
    waitcnt(1_600_000 + cnt)

  PWM[0].update(0)  
  Drive_Servo(Steer_Pin, center)
        
Pub Flash_LED(Pin)
  Dira[Pin] := 1
  Outa[Pin] := High
  waitcnt(40_000_000 + cnt)
  Outa[Pin] := Low
  waitcnt(40_000_000 + cnt)

Pub Pulsout(Pin, Duration, Polarity) | Time
  Dira[Pin] := 1
  Outa[Pin] := !Polarity
  Time := Duration * 80
  !Outa[Pin]
  waitcnt(Time + cnt)
  !Outa[Pin]

Pub Ping_Scan(Pin, Servo_Pin) : Return_Angle | Left, Right

  Drive_Servo(Ping_Turn, 750)
  Left := Ping.Inches(Ping_Pin)

  Drive_Servo(Ping_Turn, 2225)
  Right := Ping.Inches(Ping_Pin)

  Drive_Servo(Ping_Turn, 1475)

  if Left > Right
    Return_Angle := -1
  elseif Right > Left
    Return_Angle := 1  

PUB Drive_Servo(Pin, Angle)
  repeat 100
    Pulsout(Pin, Angle, High)
    waitcnt(1_600_000 + cnt)                            